Index: src/Tesselation/CandidateForTesselation.cpp
===================================================================
--- src/Tesselation/CandidateForTesselation.cpp	(revision 59fff1699458425079bb0a93f0c33d6ce50aae7d)
+++ src/Tesselation/CandidateForTesselation.cpp	(revision 53c7fc2e5e8198eaf2ef2d962e2e7c72910e48ae)
@@ -31,10 +31,7 @@
 #include "CodePatterns/Assert.hpp"
 #include "CodePatterns/Info.hpp"
-//#include "Line.hpp"
-#include "linkedcell.hpp"
 #include "CodePatterns/Log.hpp"
-//#include "Plane.hpp"
 #include "LinearAlgebra/Vector.hpp"
-#include "CodePatterns/Verbose.hpp"
+#include "LinkedCell/linkedcell.hpp"
 
 using namespace std;
Index: src/Tesselation/boundary.cpp
===================================================================
--- src/Tesselation/boundary.cpp	(revision 59fff1699458425079bb0a93f0c33d6ce50aae7d)
+++ src/Tesselation/boundary.cpp	(revision 53c7fc2e5e8198eaf2ef2d962e2e7c72910e48ae)
@@ -33,8 +33,8 @@
 #include "LinearAlgebra/Plane.hpp"
 #include "LinearAlgebra/RealSpaceMatrix.hpp"
-#include "linkedcell.hpp"
+#include "LinkedCell/linkedcell.hpp"
+#include "LinkedCell/PointCloudAdaptor.hpp"
 #include "molecule.hpp"
 #include "MoleculeListClass.hpp"
-#include "PointCloudAdaptor.hpp"
 #include "RandomNumbers/RandomNumberGeneratorFactory.hpp"
 #include "RandomNumbers/RandomNumberGenerator.hpp"
Index: src/Tesselation/ellipsoid.cpp
===================================================================
--- src/Tesselation/ellipsoid.cpp	(revision 59fff1699458425079bb0a93f0c33d6ce50aae7d)
+++ src/Tesselation/ellipsoid.cpp	(revision 53c7fc2e5e8198eaf2ef2d962e2e7c72910e48ae)
@@ -27,13 +27,12 @@
 #include <set>
 
+#include "CodePatterns/Log.hpp"
+#include "ellipsoid.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "LinearAlgebra/RealSpaceMatrix.hpp"
+#include "LinkedCell/linkedcell.hpp"
 #include "Tesselation/BoundaryPointSet.hpp"
 #include "Tesselation/boundary.hpp"
-#include "ellipsoid.hpp"
-#include "linkedcell.hpp"
-#include "CodePatterns/Log.hpp"
-#include "tesselation.hpp"
-#include "LinearAlgebra/Vector.hpp"
-#include "LinearAlgebra/RealSpaceMatrix.hpp"
-#include "CodePatterns/Verbose.hpp"
+#include "Tesselation/tesselation.hpp"
 
 #include "RandomNumbers/RandomNumberGeneratorFactory.hpp"
Index: src/Tesselation/tesselation.cpp
===================================================================
--- src/Tesselation/tesselation.cpp	(revision 59fff1699458425079bb0a93f0c33d6ce50aae7d)
+++ src/Tesselation/tesselation.cpp	(revision 53c7fc2e5e8198eaf2ef2d962e2e7c72910e48ae)
@@ -23,4 +23,6 @@
 #include <iomanip>
 #include <sstream>
+
+#include "tesselation.hpp"
 
 #include "BoundaryPointSet.hpp"
@@ -35,5 +37,4 @@
 #include "CodePatterns/Verbose.hpp"
 #include "Helpers/helpers.hpp"
-#include "IPointCloud.hpp"
 #include "LinearAlgebra/Exceptions.hpp"
 #include "LinearAlgebra/Line.hpp"
@@ -41,7 +42,7 @@
 #include "LinearAlgebra/Vector.hpp"
 #include "LinearAlgebra/vector_ops.hpp"
-#include "linkedcell.hpp"
-#include "PointCloudAdaptor.hpp"
-#include "tesselation.hpp"
+#include "LinkedCell/IPointCloud.hpp"
+#include "LinkedCell/linkedcell.hpp"
+#include "LinkedCell/PointCloudAdaptor.hpp"
 #include "tesselationhelpers.hpp"
 #include "TesselPoint.hpp"
Index: src/Tesselation/tesselationhelpers.cpp
===================================================================
--- src/Tesselation/tesselationhelpers.cpp	(revision 59fff1699458425079bb0a93f0c33d6ce50aae7d)
+++ src/Tesselation/tesselationhelpers.cpp	(revision 53c7fc2e5e8198eaf2ef2d962e2e7c72910e48ae)
@@ -21,4 +21,6 @@
 
 #include <fstream>
+
+#include "tesselationhelpers.hpp"
 
 #include "BoundaryLineSet.hpp"
@@ -30,5 +32,4 @@
 #include "CodePatterns/Log.hpp"
 #include "CodePatterns/Verbose.hpp"
-#include "IPointCloud.hpp"
 #include "LinearAlgebra/Line.hpp"
 #include "LinearAlgebra/LinearSystemOfEquations.hpp"
@@ -37,7 +38,7 @@
 #include "LinearAlgebra/Vector.hpp"
 #include "LinearAlgebra/vector_ops.hpp"
-#include "linkedcell.hpp"
+#include "LinkedCell/IPointCloud.hpp"
+#include "LinkedCell/linkedcell.hpp"
 #include "tesselation.hpp"
-#include "tesselationhelpers.hpp"
 
 void GetSphere(Vector * const center, const Vector &a, const Vector &b, const Vector &c, const double RADIUS)
Index: src/Tesselation/unittests/TesselationUnitTest.cpp
===================================================================
--- src/Tesselation/unittests/TesselationUnitTest.cpp	(revision 59fff1699458425079bb0a93f0c33d6ce50aae7d)
+++ src/Tesselation/unittests/TesselationUnitTest.cpp	(revision 53c7fc2e5e8198eaf2ef2d962e2e7c72910e48ae)
@@ -26,10 +26,10 @@
 #include <cstring>
 
+#include "CodePatterns/Log.hpp"
+#include "Helpers/defs.hpp"
+#include "LinkedCell/PointCloudAdaptor.hpp"
 #include "Tesselation/BoundaryLineSet.hpp"
 #include "Tesselation/BoundaryTriangleSet.hpp"
 #include "Tesselation/CandidateForTesselation.hpp"
-#include "CodePatterns/Log.hpp"
-#include "Helpers/defs.hpp"
-#include "PointCloudAdaptor.hpp"
 #include "Tesselation/TesselPoint.hpp"
 
Index: src/Tesselation/unittests/TesselationUnitTest.hpp
===================================================================
--- src/Tesselation/unittests/TesselationUnitTest.hpp	(revision 59fff1699458425079bb0a93f0c33d6ce50aae7d)
+++ src/Tesselation/unittests/TesselationUnitTest.hpp	(revision 53c7fc2e5e8198eaf2ef2d962e2e7c72910e48ae)
@@ -19,5 +19,5 @@
 #include <cppunit/extensions/HelperMacros.h>
 
-#include "linkedcell.hpp"
+#include "LinkedCell/linkedcell.hpp"
 #include "Tesselation/tesselation.hpp"
 
Index: src/Tesselation/unittests/Tesselation_BoundaryTriangleUnitTest.hpp
===================================================================
--- src/Tesselation/unittests/Tesselation_BoundaryTriangleUnitTest.hpp	(revision 59fff1699458425079bb0a93f0c33d6ce50aae7d)
+++ src/Tesselation/unittests/Tesselation_BoundaryTriangleUnitTest.hpp	(revision 53c7fc2e5e8198eaf2ef2d962e2e7c72910e48ae)
@@ -19,5 +19,5 @@
 #include <cppunit/extensions/HelperMacros.h>
 
-#include "linkedcell.hpp"
+#include "LinkedCell/linkedcell.hpp"
 #include "Tesselation/tesselation.hpp"
 
Index: src/Tesselation/unittests/Tesselation_InsideOutsideUnitTest.cpp
===================================================================
--- src/Tesselation/unittests/Tesselation_InsideOutsideUnitTest.cpp	(revision 59fff1699458425079bb0a93f0c33d6ce50aae7d)
+++ src/Tesselation/unittests/Tesselation_InsideOutsideUnitTest.cpp	(revision 53c7fc2e5e8198eaf2ef2d962e2e7c72910e48ae)
@@ -27,11 +27,11 @@
 #include <iostream>
 
+#include "CodePatterns/Log.hpp"
+#include "CodePatterns/Verbose.hpp"
+#include "Helpers/defs.hpp"
+#include "LinkedCell/PointCloudAdaptor.hpp"
 #include "Tesselation/BoundaryLineSet.hpp"
 #include "Tesselation/BoundaryTriangleSet.hpp"
 #include "Tesselation/CandidateForTesselation.hpp"
-#include "CodePatterns/Log.hpp"
-#include "CodePatterns/Verbose.hpp"
-#include "Helpers/defs.hpp"
-#include "PointCloudAdaptor.hpp"
 #include "Tesselation/TesselPoint.hpp"
 
Index: src/Tesselation/unittests/Tesselation_InsideOutsideUnitTest.hpp
===================================================================
--- src/Tesselation/unittests/Tesselation_InsideOutsideUnitTest.hpp	(revision 59fff1699458425079bb0a93f0c33d6ce50aae7d)
+++ src/Tesselation/unittests/Tesselation_InsideOutsideUnitTest.hpp	(revision 53c7fc2e5e8198eaf2ef2d962e2e7c72910e48ae)
@@ -19,5 +19,5 @@
 #include <cppunit/extensions/HelperMacros.h>
 
-#include "linkedcell.hpp"
+#include "LinkedCell/linkedcell.hpp"
 #include "Tesselation/tesselation.hpp"
 